## ros-noetic-canopen-master 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(canopen_master)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_STANDARD 14)
endif()

find_package(catkin REQUIRED
  COMPONENTS
    class_loader
    socketcan_interface
)

find_package(Boost REQUIRED
  COMPONENTS
    atomic
    chrono
    thread
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    socketcan_interface
  DEPENDS
    Boost
)
include_directories(include ${catkin_INCLUDE_DIRS})

add_library(${PROJECT_NAME}
  src/emcy.cpp
  src/node.cpp
  src/objdict.cpp
  src/pdo.cpp
  src/sdo.cpp
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_library(${PROJECT_NAME}_plugin
  src/master_plugin.cpp
)

target_link_libraries(${PROJECT_NAME}_plugin
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  ${PROJECT_NAME}
)

# canopen_bcm_sync
add_executable(canopen_bcm_sync
  src/bcm_sync.cpp
)
target_link_libraries(canopen_bcm_sync
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

install(
  TARGETS
    canopen_bcm_sync
    ${PROJECT_NAME}
   ${PROJECT_NAME}_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(
  FILES
    master_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-test_parser
    test/test_parser.cpp
  )
  target_link_libraries(${PROJECT_NAME}-test_parser
    ${PROJECT_NAME}
  )
endif()

=== debian/changelog ===
ros-noetic-canopen-master (0.8.5-1focal) focal; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 21 Sep 2020 22:00:00 -0000

ros-noetic-canopen-master (0.8.4-1focal) focal; urgency=high

  * added settings parameter to DriverInterface::init
  * moved canopen::Settings into can namespace
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 21 Aug 2020 22:00:00 -0000

ros-noetic-canopen-master (0.8.3-1focal) focal; urgency=high

  * Bump CMake version to avoid CMP0048 warning
    Signed-off-by: ahcorde <mailto:ahcorde@gmail.com>
  * Contributors: ahcorde

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Wed, 06 May 2020 22:00:00 -0000

ros-noetic-canopen-master (0.8.2-1focal) focal; urgency=high

  * implemented LayerStatus::equals<>()
  * added support for SYNC counter in SimpleSyncLayer (#349 <https://github.com/ipa-mdl/ros_canopen/issues/349>)
  * enable rosconsole_bridge bindings
  * switch to new logging macros
  * add logging based on console_bridge
  * removed implicit Header operator
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 03 Nov 2019 23:00:00 -0000

ros-noetic-canopen-master (0.8.1-1focal) focal; urgency=high

  * Set C++ standard to c++14
  * added Delegate helpers for backwards compatibility
  * implemented create*ListenerM helpers
  * Replacing FastDelegate with std::function and std::bind.
  * Contributors: Harsh Deshpande, Joshua Whitley, Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 13 Jul 2019 22:00:00 -0000

ros-noetic-canopen-master (0.8.0-1focal) focal; urgency=high

  * migrated to std::function and std::bind
  * migrated to std::atomic
  * got rid of boost::noncopyable
  * replaced BOOST_FOREACH
  * migrated to std::unordered_map and std::unordered_set
  * migrated to std pointers
  * provided KeyHash
    for use with unordered containers
  * added c_array access functons to can::Frame
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 10 Jul 2018 22:00:00 -0000

ros-noetic-canopen-master (0.7.8-1focal) focal; urgency=high

  * Revert "pull make_shared into namespaces"
    This reverts commit 9b2cd05df76d223647ca81917d289ca6330cdee6.
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-noetic-canopen-master (0.7.7-1focal) focal; urgency=high

  * added types for all function objects
  * pull make_shared into namespaces
  * added types for all shared_ptrs
  * migrate to new classloader headers
  * throw bad_cast if datatype is not supported
  * special handling of std::bad_cast
  * address catkin_lint errors/warnings
  * removed IPC/SHM based sync masters
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-noetic-canopen-master (0.7.6-1focal) focal; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 29 Aug 2017 22:00:00 -0000

ros-noetic-canopen-master (0.7.5-1focal) focal; urgency=high

  * added EMCYHandler::resetErrors
  * added VectorHelper::callFunc
    generalized call templates
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 28 May 2017 22:00:00 -0000

ros-noetic-canopen-master (0.7.4-1focal) focal; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-noetic-canopen-master (0.7.3-1focal) focal; urgency=high

  * enforce boost::chrono-based timer
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-noetic-canopen-master (0.7.2-1focal) focal; urgency=high

  * fix: handle EMCY as error, not as warning
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-noetic-canopen-master (0.7.1-1focal) focal; urgency=high

  * refactored EMCY handling into separate layer
  * print EMCY to stdout
  * send node start on recover
    needed for external sync to work properly
  * pass halt on error unconditionally
  * added canopen_bcm_sync
  * implemented ExternalMaster
  * added object access services
  * implemented ObjectStorage::getStringReader
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 19 Mar 2017 23:00:00 -0000

ros-noetic-canopen-master (0.7.0-1focal) focal; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 12 Dec 2016 23:00:00 -0000

ros-noetic-canopen-master (0.6.5-1focal) focal; urgency=high

  * Merge pull request #179 <https://github.com/ipa-mdl/ros_canopen/issues/179> from ipa-mdl/mixed_case_access
    support mixed-case access strings in EDS
  * decouple listener initialization from 1003 binding
  * introduced THROW_WITH_KEY and ObjectDict::key_info
  * added access type tests
  * convert access string to lowercase
  * Do not remove shared memory automatically
  * hardened code with the help of cppcheck
  * throw verbose exception if AccessType is missing (#64 <https://github.com/ipa-mdl/ros_canopen/issues/64>)
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * canopen_master needs to depend on rosunit for gtest
  * update package URLs
  * fixed typo
  * do not reset PDO COB-ID if it is not writable
  * Do not recurse into sub-objects, handle them as simple data
  * strip string before searching for $NODEID
  * added NodeID/hex parser test
  * do full recover if if driver is not ready
  * wait for driver to be shutdown in run()
  * limit SDO reader to size of 1
  * do not send abort twice
  * removed unnecessary sleep (added for tests only)
  * catch all std exceptions in layer handlers
  * migrated SDOClient to BufferedReader
  * getter for LayerState


=== debian/control ===
Source: ros-noetic-canopen-master
Section: misc
Priority: optional
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-noetic-catkin, ros-noetic-class-loader, ros-noetic-rosunit, ros-noetic-socketcan-interface
Homepage: http://wiki.ros.org/canopen_master
Standards-Version: 3.9.2

Package: ros-noetic-canopen-master
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-noetic-class-loader, ros-noetic-socketcan-interface
Description: CiA(r) CANopen 301 master implementation with support for interprocess master synchronisation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-canopen-master//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
